diff --git a/gdb/stack.c b/gdb/stack.c
index 9993ae6..19f2381 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -268,6 +268,7 @@ print_frame_arg (const struct frame_arg *arg)
 	    {
 	      const struct language_defn *language;
 	      struct value_print_options opts;
+	      const struct language_defn *saved_current_language = NULL;
 
 	      /* Avoid value_print because it will deref ref parameters.  We
 		 just want to print their addresses.  Print ??? for args whose
@@ -277,10 +278,24 @@ print_frame_arg (const struct frame_arg *arg)
 
 	      annotate_arg_value (value_type (arg->val));
 
-	      /* Use the appropriate language to display our symbol, unless the
-		 user forced the language to a specific language.  */
+	      /* Use the appropriate language to display our symbol,
+		 unless the user forced the language to a specific
+		 language.
+		 There's a problem when using language_mode_auto since
+		 some language specific functions do not print properly
+		 the frame argument because they do not have/use the
+		 LANGUAGE parameter given to common_val_print but use
+		 global current_language variable instead.
+		 To solve this, we switch the current language to the
+		 language of the frame argument for each argument then
+		 we finally restore the current language.  */
+
 	      if (language_mode == language_mode_auto)
-		language = language_def (SYMBOL_LANGUAGE (arg->sym));
+		{
+		  language = language_def (SYMBOL_LANGUAGE (arg->sym));
+		  saved_current_language = current_language;
+		  current_language = language;
+		}
 	      else
 		language = current_language;
 
@@ -292,6 +307,9 @@ print_frame_arg (const struct frame_arg *arg)
 	      opts.summary = !strcmp (print_frame_arguments, "scalars");
 
 	      common_val_print (arg->val, &stb, 2, &opts, language);
+
+	      if (saved_current_language != NULL)
+		  current_language = saved_current_language;
 	    }
 	  CATCH (except, RETURN_MASK_ERROR)
 	    {
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang.exp b/gdb/testsuite/gdb.ada/frame_arg_lang.exp
new file mode 100644
index 0000000..d387977
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang.exp
@@ -0,0 +1,74 @@
+# Copyright 2018 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+load_lib "ada.exp"
+
+standard_ada_testfile bla
+set cfile "${testdir}/foo"
+set csrcfile ${srcdir}/${subdir}/${cfile}.c
+set cobject [standard_output_file ${cfile}.o]
+
+gdb_compile "${csrcfile}" "${cobject}" object [list debug]
+if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug additional_flags=-largs additional_flags=${cobject} additional_flags=-margs]] != "" } {
+  return -1
+}
+
+clean_restart ${testfile}
+
+set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.c]
+runto "foo.c:$bp_location"
+
+gdb_test_no_output "set print frame-arguments all"
+
+# Here is the scenario:
+#  - Once stopped in a C function, with language_mode set to auto, print
+#    backtrace, we should see the Ada frame arguments printed using Ada
+#    syntax.
+#  - Set language to C, then check that printing backtrace shows the Ada
+#    frame arguments using C syntax.
+#  - Set language back to auto, check language mode value, then print
+#    backtrace, we should see Ada frame arguments printed using Ada C
+#    syntax.
+
+gdb_test "show lang" \
+         "The current source language is \"auto; currently c\"." \
+         "show language #1"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s=\"test\"\\).*" \
+         "backtrace (auto: c)"
+
+gdb_test_no_output "set language c" \
+                   "Set current source language to \"manual; currently c\"."
+
+gdb_test "show lang" \
+         "The current source language is \"c\"." \
+         "show language #2"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s={P_ARRAY = $hex, P_BOUNDS = $hex}\\).*" \
+         "backtrace (manual: c)"
+
+gdb_test_no_output "set language auto" \
+                   "Set current source language to \"auto; currently c\"."
+
+gdb_test "show lang" \
+         "The current source language is \"auto; currently c\"." \
+         "show language #3"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s=\"test\"\\).*" \
+         "backtrace (auto: ada)"
+
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb b/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb
new file mode 100644
index 0000000..dc772d6
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb
@@ -0,0 +1,22 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+with Pck; use Pck;
+
+procedure Bla is
+   S : String := "test";
+begin
+   Call_Me (S);
+end Bla;
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c b/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c
new file mode 100644
index 0000000..859d23c
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c
@@ -0,0 +1,22 @@
+/* Copyright 2018 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+int
+break_me (void)
+{
+  return 0; /* STOP */
+}
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb
new file mode 100644
index 0000000..3d674a4
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb
@@ -0,0 +1,24 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package body Pck is
+   procedure C_Break_Me;
+   pragma Import (C, C_Break_Me, "break_me");
+
+   procedure Call_Me (S: in out String) is
+   begin
+      C_Break_Me;
+   end Call_Me;
+end Pck;
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads
new file mode 100644
index 0000000..2f6ee60
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads
@@ -0,0 +1,18 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package Pck is
+   procedure Call_Me (S: in out String);
+end Pck;