diff --git a/gdb/ada-valprint.c b/gdb/ada-valprint.c
index a486919..f6a1132 100644
--- a/gdb/ada-valprint.c
+++ b/gdb/ada-valprint.c
@@ -33,6 +33,8 @@
 #include "objfiles.h"
 #include "target-float.h"
 
+extern const struct language_defn ada_language_defn;
+
 static int print_field_values (struct type *, const gdb_byte *,
 			       int,
 			       struct ui_file *, int,
@@ -1208,7 +1210,7 @@ ada_val_print (struct type *type,
     {
       ada_val_print_1 (type, embedded_offset, address,
 		       stream, recurse, val, options,
-		       current_language);
+		       &ada_language_defn);
     }
   CATCH (except, RETURN_MASK_ERROR)
     {
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang.exp b/gdb/testsuite/gdb.ada/frame_arg_lang.exp
new file mode 100644
index 0000000..5a8193f
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang.exp
@@ -0,0 +1,74 @@
+# Copyright 2018 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+load_lib "ada.exp"
+
+standard_ada_testfile bla
+set cfile "foo"
+set csrcfile ${srcdir}/${subdir}/${testdir}/${cfile}.c
+set cobject [standard_output_file ${cfile}.o]
+
+gdb_compile "${csrcfile}" "${cobject}" object [list debug]
+if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug additional_flags=-largs additional_flags=${cobject} additional_flags=-margs]] != "" } {
+  return -1
+}
+
+clean_restart ${testfile}
+
+set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.c]
+runto "foo.c:$bp_location"
+
+gdb_test_no_output "set print frame-arguments all"
+
+# Here is the scenario:
+#  - Once stopped in a C function, with language_mode set to auto, print
+#    backtrace, we should see the Ada frame arguments printed using Ada
+#    syntax.
+#  - Set language to C, then check that printing backtrace shows the Ada
+#    frame arguments using C syntax.
+#  - Set language back to auto, check language mode value, then print
+#    backtrace, we should see Ada frame arguments printed using Ada C
+#    syntax.
+
+gdb_test "show lang" \
+         "The current source language is \"auto; currently c\"." \
+         "show language #1"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s=\"test\"\\).*" \
+         "backtrace with auto: c"
+
+gdb_test_no_output "set language c" \
+                   "Set current source language to \"manual; currently c\"."
+
+gdb_test "show lang" \
+         "The current source language is \"c\"." \
+         "show language #2"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s={P_ARRAY = $hex, P_BOUNDS = $hex}\\).*" \
+         "backtrace with manual: c"
+
+gdb_test_no_output "set language auto" \
+                   "Set current source language to \"auto; currently c\"."
+
+gdb_test "show lang" \
+         "The current source language is \"auto; currently c\"." \
+         "show language #3"
+
+gdb_test "bt" \
+         "#1  $hex in pck\\.call_me \\(s=\"test\"\\).*" \
+         "backtrace with auto: ada"
+
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb b/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb
new file mode 100644
index 0000000..dc772d6
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/bla.adb
@@ -0,0 +1,22 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+with Pck; use Pck;
+
+procedure Bla is
+   S : String := "test";
+begin
+   Call_Me (S);
+end Bla;
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c b/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c
new file mode 100644
index 0000000..859d23c
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/foo.c
@@ -0,0 +1,22 @@
+/* Copyright 2018 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+int
+break_me (void)
+{
+  return 0; /* STOP */
+}
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb
new file mode 100644
index 0000000..3d674a4
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.adb
@@ -0,0 +1,24 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package body Pck is
+   procedure C_Break_Me;
+   pragma Import (C, C_Break_Me, "break_me");
+
+   procedure Call_Me (S: in out String) is
+   begin
+      C_Break_Me;
+   end Call_Me;
+end Pck;
diff --git a/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads
new file mode 100644
index 0000000..2f6ee60
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/frame_arg_lang/pck.ads
@@ -0,0 +1,18 @@
+--  Copyright 2018 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package Pck is
+   procedure Call_Me (S: in out String);
+end Pck;