diff --git a/gdb/testsuite/gdb.base/load-command.c b/gdb/testsuite/gdb.base/load-command.c
new file mode 100644
index 0000000000..ee73e2be17
--- /dev/null
+++ b/gdb/testsuite/gdb.base/load-command.c
@@ -0,0 +1,22 @@
+/* This test program is part of GDB, the GNU debugger.
+
+   Copyright 2018 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+int the_variable = 0x1234;
+
+int main ()
+{
+}
diff --git a/gdb/testsuite/gdb.base/load-command.exp b/gdb/testsuite/gdb.base/load-command.exp
new file mode 100644
index 0000000000..61ca272f17
--- /dev/null
+++ b/gdb/testsuite/gdb.base/load-command.exp
@@ -0,0 +1,49 @@
+# Copyright 2018 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test the "load" command.
+
+standard_testfile
+
+# Disable generation of position independent executable (PIE).  Otherwise, we
+# would have to manually specify an offset to load.
+
+set opts {debug ldflags=-no-pie}
+
+if [prepare_for_testing "failed to prepare" $testfile $srcfile $opts] {
+    return -1
+}
+
+if ![runto_main] {
+    fail "can't run to main"
+    return -1
+}
+
+# The native target does not support the load command.
+if [gdb_is_target_native] {
+    unsupported "the native target does not support the load command"
+    return
+}
+
+# Manually change the value of the_variable.
+gdb_test "print/x the_variable" " = 0x1234" "check initial value of the_variable"
+gdb_test_no_output "set the_variable = 0x5555" "manually change the_variable"
+gdb_test "print/x the_variable" " = 0x5555" "check manually changed value of the_variable"
+
+# Re-load the binary using the load command.
+gdb_test "load ${binfile}" ".*Loading section .data.*Transfer rate:.*" "re-load binary"
+
+# Re-loading the binary should have reset the variable value.
+gdb_test "print/x the_variable" " = 0x1234" "check initial value of the_variable"
diff --git a/gdb/testsuite/lib/gdb.exp b/gdb/testsuite/lib/gdb.exp
index e90c461403..3cd10dcafb 100644
--- a/gdb/testsuite/lib/gdb.exp
+++ b/gdb/testsuite/lib/gdb.exp
@@ -3154,14 +3154,19 @@ proc skip_compile_feature_tests {} {
     return $result
 }
 
-# Helper for gdb_is_target_remote.  PROMPT_REGEXP is the expected
-# prompt.
+# Helper for gdb_is_target_* procs.  TARGET_NAME is the name of the target
+# we're looking for (used to build the test name).  TARGET_STACK_REGEXP
+# is a regexp that will match the output of "maint print target-stack" if
+# the target in question is currently pushed.
 
-proc gdb_is_target_remote_prompt { prompt_regexp } {
+proc gdb_is_target_1 { target_name target_stack_regexp } {
+    global gdb_prompt
+
+    set prompt_regexp "$gdb_prompt $"
 
-    set test "probe for target remote"
+    set test "probe for target ${target_name}"
     gdb_test_multiple "maint print target-stack" $test {
-	-re ".*emote serial target in gdb-specific protocol.*$prompt_regexp" {
+	-re "${target_stack_regexp}${prompt_regexp}" {
 	    pass $test
 	    return 1
 	}
@@ -3175,10 +3180,14 @@ proc gdb_is_target_remote_prompt { prompt_regexp } {
 # Check whether we're testing with the remote or extended-remote
 # targets.
 
-proc gdb_is_target_remote {} {
-    global gdb_prompt
+proc gdb_is_target_remote { } {
+    return [gdb_is_target_1 "remote" ".*emote serial target in gdb-specific protocol.*"]
+}
+
+# Check whether we're testing with the native target.
 
-    return [gdb_is_target_remote_prompt "$gdb_prompt $"]
+proc gdb_is_target_native { } {
+    return [gdb_is_target_1 "native" ".*native \\(Native process\\).*"]
 }
 
 # Return the effective value of use_gdb_stub.